/*
 * Copyright (C) 1996 Julian Byrne
 * Permission to reproduce for non-commercial purposes granted.
 *
 * Title:        Printenv Wrapper
 * File name:    printenv.c
 * Version:      1.1
 * Usage:        printenv
 * Description:  Echos the program environment in HTML form.
 * Dependencies: CGI compliant web server
 * Author:       Julian Byrne
 * Internet:     julian.byrne@eng.monash.edu.au (NO JUNK MAIL!)
 * Web:          http://kryten.eng.monash.edu.au/~jcb
 * History:      96/ 7/26 Initial version
 *               96/ 8/18 Cleaned up some nits.
 * Notes:
 */

#include <stdio.h>
#include <stdlib.h>

void armor(char *s)
{
  int i;

  for (i = 0; s[i] != '\0'; i++)
    switch(s[i]) {
      case '&' : fputs("&amp;" , stdout); break;
      case '<' : fputs("&lt;"  , stdout); break;
      case '>' : fputs("&gt;"  , stdout); break;
      case '"' : fputs("&quot;", stdout); break;
      default  : putchar(s[i]);           break; }
}

int main(int argc, char *argv[], char *envp[])
{
  int i;

  fputs("Content-type: text/html\nPragma: no-cache\n\n<html>\n<head>\n\
<title>Environment</title>\n</head>\n<body bgcolor=\"#FFFFFF\">\n\
<h1 align=\"Center\">Environment</h1>\n", stdout);

  if (0 < argc && argv[0] != NULL) {
    fputs("ARGV=", stdout);

    for (i = 0; i < argc && argv[i] != NULL; i++) {
      if (i > 0)
        putchar(' ');
      armor(argv[i]); }

    fputs("<br>\n", stdout); }

  for (i = 0; envp[i] != NULL; i++) {
    armor(envp[i]);
    fputs("<br>\n", stdout); }

  fputs("</body>\n</html>\n", stdout);

  return EXIT_SUCCESS;
}
